# https://taskfile.dev

version: '3'

dotenv:
  - '.env'

env:
  DOCKER_BUILDKIT: '1'

vars:
  VERSION:
    sh: cat node/config/version.go | grep -A 1 "func GetVersion() \[\]byte {" | grep -Eo '0x[0-9a-fA-F]+' | xargs printf "%d.%d.%d"
  GIT_REPO:
    sh: git config --get remote.origin.url | sed 's/\.git$//'
  GIT_BRANCH:
    sh: git rev-parse --abbrev-ref HEAD
  GIT_COMMIT:
    sh: git log -1 --format=%h
  MAX_KEY_ID: 17

tasks:
  status:
    desc: Display configuration info.
    cmds:
      - echo -n "Image name:" && echo " ${QUILIBRIUM_IMAGE_NAME:-quilibrium}"
      - echo -n "Version   :" && echo " {{.VERSION}}"
      - echo -n "Repo      :" && echo " {{.GIT_REPO}}"
      - echo -n "Branch    :" && echo " {{.GIT_BRANCH}}"
      - echo -n "Commit    :" && echo " {{.GIT_COMMIT}}"
      - echo -n "Max Key ID:" && echo " {{.MAX_KEY_ID}}"
    silent: true
    
  build_node_arm64_macos:
    desc: Build the Quilibrium node binary for MacOS ARM. Assumes it's ran from the same platform. Outputs to node/build.
    cmds:
      - vdf/generate.sh
      - node/build.sh -o build/arm64_macos/node

  build_node_arm64_linux:
    desc: Build the Quilibrium node binary for ARM64 Linux. Outputs to node/build.
    cmds:
      - docker build --platform linux/arm64 -f Dockerfile.source --output node/build/arm64_linux --target=node .

  build_node_amd64_linux:
    desc: Build the Quilibrium node binary for AMD64 Linux. Outputs to node/build.
    cmds:
      - docker build --platform linux/amd64 -f Dockerfile.source --output node/build/amd64_linux --target=node .

  build:source:
    desc: Build the Quilibrium docker image from source.
    cmds:
      - |
        docker build \
        -f Dockerfile.source \
        --build-arg NODE_VERSION={{.VERSION}} \
        --build-arg GIT_REPO={{.GIT_REPO}} \
        --build-arg GIT_BRANCH={{.GIT_BRANCH}} \
        --build-arg GIT_COMMIT={{.GIT_COMMIT}} \
        -t ${QUILIBRIUM_IMAGE_NAME:-quilibrium}:{{.VERSION}}-source \
        -t ${QUILIBRIUM_IMAGE_NAME:-quilibrium}:source \
        .
    status:
      - |
        docker image inspect \
        ${QUILIBRIUM_IMAGE_NAME:-quilibrium}:{{.VERSION}}-source \
        >/dev/null 2>/dev/null

  build:release:
    desc: Build the Quilibrium docker image from release binaries.
    aliases:
      - build
    cmds:
      - |
        docker build \
        -f Dockerfile.release \
        --build-arg NODE_VERSION={{.VERSION}} \
        --build-arg GIT_REPO={{.GIT_REPO}} \
        --build-arg GIT_BRANCH={{.GIT_BRANCH}} \
        --build-arg GIT_COMMIT={{.GIT_COMMIT}} \
        --build-arg MAX_KEY_ID={{.MAX_KEY_ID}} \
        -t ${QUILIBRIUM_IMAGE_NAME:-quilibrium}:{{.VERSION}}-release \
        -t ${QUILIBRIUM_IMAGE_NAME:-quilibrium}:release \
        .
    status:
      - |
        docker image inspect \
        ${QUILIBRIUM_IMAGE_NAME:-quilibrium}:{{.VERSION}}-release \
        >/dev/null 2>/dev/null

  docker:login:
    desc: Login to Docker hub
    aliases:
      - login
    cmds:
      - echo $DOCKER_TOKEN | docker login -u $DOCKER_USERNAME --password-stdin

  push:
    desc: Push Quilibrium docker image to the container registry.
    cmds:
      - docker push ${QUILIBRIUM_IMAGE_NAME:-quilibrium}:{{.VERSION}}
      - docker push ${QUILIBRIUM_IMAGE_NAME:-quilibrium}:latest
